﻿Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Creating DataTable
        Dim dataTable As New DataTable()

        ' Add columns to the data table
        dataTable.Columns.Add("ID", GetType(String))
        dataTable.Columns.Add("FirstName", GetType(String))
        dataTable.Columns.Add("LastName", GetType(String))
        dataTable.Columns.Add("Country", GetType(String))

        ' Add rows to the data table
        dataTable.Rows.Add("1", "Louis", "Jane", "United States")
        dataTable.Rows.Add("2", "White", "Greg", "Japan")
        dataTable.Rows.Add("3", "Vironica", "Franklin", "Africa")
        dataTable.Rows.Add("4", "Rick", "Daniels", "United Kingdom")
        dataTable.Rows.Add("5", "Bolt", "Chancey", "Australia")
        dataTable.Rows.Add("6", "Make", "Woth", "Australia")
        dataTable.Rows.Add("7", "Bingi", "Chancey", "Australia")
        dataTable.Rows.Add("8", "Claus", "James", "Australia")

        ' Setting the datasource to C1TrueDbGrid
        c1TrueDBGrid1.SetDataBinding(dataTable, "")

        Dim menu As New ContextMenu()
        menu.MenuItems.Add("Copy")
        menu.MenuItems.Add("Paste")

        'Create Comtext Menu for the Grid
        c1TrueDBGrid1.ContextMenu = menu
        AddHandler menu.MenuItems(0).Click, AddressOf menu_CopyClick
        AddHandler menu.MenuItems(1).Click, AddressOf menu_PasteClick
    End Sub
    Dim selRow, selCol As Integer

    Private Function ClipBoardValues(clipboardValue As String) As Dictionary(Of Integer, Dictionary(Of Integer, String))
        Dim copyValues As New Dictionary(Of Integer, Dictionary(Of Integer, String))()
        Dim lines As [String]() = clipboardValue.Split(ControlChars.Lf)
        For i As Integer = 0 To lines.Length - 1
            copyValues(i) = New Dictionary(Of Integer, String)()
            Dim lineContent As [String]() = lines(i).Split(ControlChars.Tab)

            'if an empty cell value copied, then set the dictionay with an empty string
            'else Set value to dictionary
            If lineContent.Length = 0 Then
                copyValues(i)(0) = String.Empty
            Else
                For j As Integer = 0 To lineContent.Length - 1
                    copyValues(i)(j) = lineContent(j)
                Next
            End If
        Next
        Return copyValues
    End Function

    Private Sub menu_CopyClick(sender As Object, e As EventArgs)
        Dim strTemp As String = ""
        If Me.c1TrueDBGrid1.SelectedRows.Count > 0 Then
            selCol = c1TrueDBGrid1.SelectedCols.Count
            selRow = c1TrueDBGrid1.SelectedRows.Count
            For Each row As Integer In Me.c1TrueDBGrid1.SelectedRows
                'copy everything here
                For Each col As C1.Win.C1TrueDBGrid.C1DataColumn In Me.c1TrueDBGrid1.SelectedCols
                    strTemp = (strTemp & col.CellText(row)) + vbTab
                Next

                strTemp = strTemp & Convert.ToString(vbLf)
            Next
            System.Windows.Forms.Clipboard.SetDataObject(strTemp, False)
        Else
            MessageBox.Show("Please select a range of cells")
        End If
    End Sub
    Private Sub menu_PasteClick(sender As Object, e As EventArgs)
        Dim cbValue As Dictionary(Of Integer, Dictionary(Of Integer, String)) = ClipBoardValues(Clipboard.GetText())

        If Me.c1TrueDBGrid1.SelectedRows.Count > 0 Then
            If selCol = c1TrueDBGrid1.SelectedCols.Count AndAlso selRow = c1TrueDBGrid1.SelectedRows.Count Then
                Dim i1 As Integer = 0
                For Each row As Integer In Me.c1TrueDBGrid1.SelectedRows
                    Dim j1 As Integer = 0
                    'copy everything here
                    For Each col As C1.Win.C1TrueDBGrid.C1DataColumn In Me.c1TrueDBGrid1.SelectedCols
                        c1TrueDBGrid1(row, col.Caption) = cbValue(i1)(j1)
                        j1 += 1
                    Next
                    i1 += 1
                Next
            Else
                MessageBox.Show("Please select valid range of cells")
            End If
        Else
            MessageBox.Show("Please select a range of cells")
        End If
    End Sub
End Class
